local showAll = false

local rname, ring, ringID = "OPieOutfitter", {name = "Outfitter", hotkey = "ALT-O"}, nil

local function ringClickedComplete(ring, outfit)
	Outfitter:ExecuteCommand("wear "..outfit)
end

local function ringClickedAccessory(ring, outfit)
	Outfitter:ExecuteCommand("toggle "..outfit)
end

local function doUpdateRing()
	if ringID then
		OneRingLib:SetRingData(ringID, ring)
	elseif #ring > 0 then
		ringID = OneRingLib:CreateRing(rname, ring)
	end
end

local function UpdateSets()
--	DEFAULT_CHAT_FRAME:AddMessage("OPie Outfitter: Update sets #ring before remove: "..#ring)
	for i = 1, #ring do
		table.remove(ring, #ring)
--		DEFAULT_CHAT_FRAME:AddMessage("OPie Outfitter: Update sets #ring in for: "..#ring.." while i:"..i)
	end
--	DEFAULT_CHAT_FRAME:AddMessage("OPie Outfitter: Update sets #ring after remove: "..#ring)
	if not Outfitter:IsInitialized() then
		DEFAULT_CHAT_FRAME:AddMessage("OPie Outfitter: outfitter not initialised")
		return
	end
	local vOutfits = Outfitter:GetOutfitsByCategoryID("Complete")
	for vIndex, vOutfit in pairs(vOutfits) do
		local name = vOutfit.Name
		local icon = Outfitter.OutfitBar:GetOutfitTexture(vOutfit)
		local pos = #ring + 1
		if (showAll or Outfitter.OutfitBar:IsOutfitShown(vOutfit)) then
			table.insert(ring, pos, {"func", ringClickedComplete, name, r = 1, g = 0.75, b = 0.5, icon = icon, caption = "Wear Complete " .. name})
		end
	end

	vOutfits = Outfitter:GetOutfitsByCategoryID("Accessory")
	for vIndex, vOutfit in pairs(vOutfits) do
		local name = vOutfit.Name
		local icon = Outfitter.OutfitBar:GetOutfitTexture(vOutfit)
		local pos = #ring + 1
		if (showAll or Outfitter.OutfitBar:IsOutfitShown(vOutfit)) then
			table.insert(ring, pos, {"func", ringClickedAccessory, name, r = 0.8, g = 0.9, b = 0.5, icon = icon, caption = "Toggle Accessory " .. name})
		end
	end

	doUpdateRing()
end

Outfitter:RegisterOutfitEvent('OUTFITTER_INIT', function()
    DEFAULT_CHAT_FRAME:AddMessage("OPie_Outfitter Initialized")
	UpdateSets()
end)

Outfitter:RegisterOutfitEvent('EDIT_OUTFIT', function()
--    DEFAULT_CHAT_FRAME:AddMessage("OPie_Outfitter EDIT_OUTFIT")
	UpdateSets()
end)
